package org.dromara.zhishu.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.common.satoken.utils.LoginHelper;
import org.dromara.zhishu.domain.ZhishuShopGoods;
import org.springframework.stereotype.Service;
import org.dromara.zhishu.domain.bo.TBookAuditBo;
import org.dromara.zhishu.domain.vo.TBookAuditVo;
import org.dromara.zhishu.domain.TBookAudit;
import org.dromara.zhishu.mapper.TBookAuditMapper;
import org.dromara.zhishu.service.ITBookAuditService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 图书审核管理Service业务层处理
 *
 * @author Lion Li
 * @date 2025-04-18
 */
@RequiredArgsConstructor
@Service
public class TBookAuditServiceImpl implements ITBookAuditService {

    private final TBookAuditMapper baseMapper;

    /**
     * 查询图书审核管理
     *
     * @param id 主键
     * @return 图书审核管理
     */
    @Override
    public TBookAuditVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询图书审核管理列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 图书审核管理分页列表
     */
    @Override
    public TableDataInfo<TBookAuditVo> queryPageList(TBookAuditBo bo, PageQuery pageQuery) {
        Long userId = LoginHelper.getUserId();
        bo.setUserId(userId);
        LambdaQueryWrapper<TBookAudit> lqw = buildQueryWrapper(bo);
        Page<TBookAuditVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的图书审核管理列表
     *
     * @param bo 查询条件
     * @return 图书审核管理列表
     */
    @Override
    public List<TBookAuditVo> queryList(TBookAuditBo bo) {
        LambdaQueryWrapper<TBookAudit> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TBookAudit> buildQueryWrapper(TBookAuditBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TBookAudit> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(TBookAudit::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getProductId()), TBookAudit::getProductId, bo.getProductId());
        lqw.like(StringUtils.isNotBlank(bo.getGoodsName()), TBookAudit::getGoodsName, bo.getGoodsName());
        lqw.eq(StringUtils.isNotBlank(bo.getIsbn()), TBookAudit::getIsbn, bo.getIsbn());
        lqw.eq(StringUtils.isNotBlank(bo.getArtNo()), TBookAudit::getArtNo, bo.getArtNo());
        lqw.eq(StringUtils.isNotBlank(bo.getConditionCode()), TBookAudit::getConditionCode, bo.getConditionCode());
        lqw.eq(StringUtils.isNotBlank(bo.getItemNumber()), TBookAudit::getItemNumber, bo.getItemNumber());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), TBookAudit::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增图书审核管理
     *
     * @param bo 图书审核管理
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TBookAuditBo bo) {
        TBookAudit add = MapstructUtils.convert(bo, TBookAudit.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
//            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改图书审核管理
     *
     * @param bo 图书审核管理
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TBookAuditBo bo) {
        TBookAudit update = MapstructUtils.convert(bo, TBookAudit.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TBookAudit entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除图书审核管理信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    /**
     * 修改图书审核管理状态
     *
     * @param bo 图书审核管理
     * @return 是否修改成功
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public Boolean updateStatus(TBookAuditBo bo) {
        if(bo.getStatus().equals("0")){
            TBookAudit tBookAudit = baseMapper.selectGoods(bo.getId());
            baseMapper.deleteById(bo.getId());
        }else {
            baseMapper.deleteById(bo.getId());
        }
        return  true;
    }
}
